> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pnbr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Link library shape

> Link a public library Shape into the project.

**Operation ID:** `http.shapes.links.create`

```http theme={null}
POST /v1/orgs/{org}/projects/{project}/shapes/links
```


## OpenAPI

````yaml openapi.json POST /v1/orgs/{org}/projects/{project}/shapes/links
openapi: 3.1.0
info:
  title: Penumbra API
  version: v1
  description: >-
    HTTP reference for Files, search, extraction, reviews, Graph, Shapes and
    sharing.
servers:
  - url: https://api.pnbr.io
    description: Penumbra API
security: []
paths:
  /v1/orgs/{org}/projects/{project}/shapes/links:
    post:
      tags:
        - Shapes
      summary: Link library shape
      description: |-
        Link a public library Shape into the project.

        Product guidance: [Shape](/concepts/shape).
      operationId: http.shapes.links.create
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: project
          in: path
          required: true
          schema:
            type: string
        - name: Idempotency-Key
          in: header
          required: true
          description: >-
            1–200 printable ASCII characters, no surrounding spaces; '.' and
            '..' are reserved. Reuse this key with the same request when
            retrying an uncertain outcome.
          schema:
            type: string
            minLength: 1
            maxLength: 200
            pattern: ^(?!\.{1,2}$)[!-~](?:[ -~]*[!-~])?$
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/http_shapes_links_create_request'
      responses:
        2XX:
          description: Success.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/http_shapes_links_create_response'
      security:
        - bearerAuth: []
components:
  schemas:
    http_shapes_links_create_request:
      type: object
      properties:
        publisher:
          type: string
          pattern: ^[a-z][a-z0-9-]{1,62}$
        shape_id:
          type: string
          format: uuid
          pattern: >-
            ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
        artifact_digest:
          type: string
          pattern: ^sha256:[0-9a-f]{64}$
      required:
        - publisher
        - shape_id
        - artifact_digest
      additionalProperties: false
    http_shapes_links_create_response:
      type: object
      properties:
        request_id:
          type: string
        outcome:
          type: string
          const: applied
        replayed:
          type: boolean
        data:
          type: object
          properties:
            project_id:
              type: string
            shape_id:
              type: string
            publisher_id:
              type: string
            revision_id:
              type: string
            artifact_digest:
              type: string
            generation:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            status:
              type: string
              enum:
                - active
                - removed
            link_revision:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            linked_at:
              type: string
            removed_at:
              anyOf:
                - type: string
                - type: 'null'
          required:
            - project_id
            - shape_id
            - publisher_id
            - revision_id
            - artifact_digest
            - generation
            - status
            - link_revision
            - linked_at
            - removed_at
          additionalProperties: {}
      required:
        - request_id
        - outcome
        - replayed
        - data
      additionalProperties: {}
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.